package xyz.leomurca.rickandmorty.di

import dagger.Module
import dagger.Provides
import dagger.hilt.InstallIn
import dagger.hilt.components.SingletonComponent
import kotlinx.coroutines.CoroutineDispatcher
import xyz.leomurca.rickandmorty.data.CharacterRepository
import xyz.leomurca.rickandmorty.data.remote.RemoteCharacterRepository
import xyz.leomurca.rickandmorty.network.NetworkDataSource
import javax.inject.Singleton

@Module
@InstallIn(SingletonComponent::class)
class DataModule {

    @Provides
    @Singleton
    fun providesMovieRepository(
        @Dispatcher(AppDispatchers.IO) ioDispatcher: CoroutineDispatcher,
        dataSource: NetworkDataSource,
    ): CharacterRepository {
        return RemoteCharacterRepository(ioDispatcher, dataSource)
    }
}